PROGRAM_NAME='MASTER'

DEFINE_DEVICE 
dvTP = 10001:1:0

DEFINE_CONSTANT
//dropTargets
INTEGER btnDT1 	= 11
INTEGER btnDT2 	= 12
INTEGER btnDT3 	= 13
INTEGER btnDT4 	= 14
//draggables
INTEGER btnDG1	= 1
INTEGER btnDG2	= 2
INTEGER btnDG3	= 3
INTEGER btnDG4	= 4
INTEGER btnDG5	= 5

DEFINE_VARIABLE
//draggables
INTEGER dgBTNS[] = {btnDG1 ,btnDG2 ,btnDG3 ,btnDG4,btnDG5}
//drag targets
INTEGER dgTARGETS[] = {btnDT1 ,btnDT2 ,btnDT3 ,btnDT4}
//group_1
INTEGER dgG1[] = {btnDG1,btnDG5}
//group_2
INTEGER dgG2[] = {btnDG2,btnDG3,btnDG4}
//to store draggable address from start event
INTEGER nDragAddress = 0
SINTEGER nValidTarget
INTEGER nTV1Source
INTEGER nTV2Source
INTEGER nVTCSource
DEFINE_MUTUALLY_EXCLUSIVE
([dvTP,1]..[dvTP,5])

//In this example the groups are defined as follows
//	- buttonAddresses 1,5, are assigned: group_1
//	- buttonAddresses 2,3,4 are assigned: group_2
DEFINE_EVENT

DATA_EVENT[dvTP]
{
    ONLINE:
    {
	//Enable all drag and drop custom events
	//Overloading events 2&3 (drag enter/exit) events to evaluate
	//valid/invalid drop targets within the same event using custom flag value
	SEND_COMMAND dvTP,"'^BDC-1,2,3,4,5,2,3'"
	SEND_COMMAND dvTP,"'^BMP-31.33,0,blank.png'"
    }
}

//Custom event for START [1]
//Anytime a draggable is initiated (long press, dragShadow appears)
//a START event is sent.
CUSTOM_EVENT[dvTP,dgBTNS,1]
{
    SLONG dgBTN
    SLONG dtBTN
    
    //Get the dragButtonAddress from the customEvent
    dgBTN = custom.value1
    nDragAddress = dgBTN
    //Get the dropTargetButtonAddress from the customEvent
    dtBTN = custom.value2
    SEND_STRING 0,"'start = ', ITOA(dgBTN)"    
}
//Custom event for ENTER [2]
//Once the dragShadow enters the boundaries of a valid dropTarget
//a ENTER event is sent
CUSTOM_EVENT[dvTP,dgTARGETS,2]
{
   SEND_STRING 0,"'entered = ', ITOA(CUSTOM.VALUE1)"
   // Valid drop target is zero, invalid drop target is -1
   IF(CUSTOM.FLAG = 0)
    SEND_COMMAND dvTP,"'^ANI-',ITOA(get_last(dgTARGETS)+10),',1,2,0'"
   ELSE 
    SEND_COMMAND dvTP,"'^ANI-',ITOA(get_last(dgTARGETS)+10),',1,3,0'"
   send_string 0,"'nDT=',itoa(get_last(dgTARGETS))"
   nValidTarget = CUSTOM.FLAG
}
//Custom event for EXIT [3]
//Once the dragShadow leaves the boundaries of a valid dropTarget
//a EXIT event is sent
CUSTOM_EVENT[dvTP,dgTARGETS,3]
{
   SEND_STRING 0,"'exited = ', ITOA(CUSTOM.VALUE1)"  
   SEND_COMMAND dvTP,"'^ANI-',ITOA(get_last(dgTARGETS)+10),',1,1,0'"
}
//Custom event for DROP [4]
//A DROP event occurs when a draggable has been released within the boundaries
//of a valid dropTarget.  A valid dropTarget is a dropTarget that has a group
//which the draggable is assigned to.
CUSTOM_EVENT[dvTP,dgTARGETS,4]
{
    SEND_STRING 0,"'drag = ', ITOA(CUSTOM.VALUE1), ' drop = ', ITOA(CUSTOM.VALUE2), ' group = ', CUSTOM.TEXT"
    SEND_COMMAND dvTP,"'^ANI-',ITOA(get_last(dgTARGETS)+10),',1,1,0'"
    
    //if valid drop target
  IF(nValidTarget = 0)
  {
    //turn on the draggable
    ON[dvTP,get_last(dgBTNS)]
    
    IF(CUSTOM.VALUE2 = 11)//left display
      nTV1Source = get_last(dgBTNS)
    IF(CUSTOM.VALUE2 = 12)//vtideo conference
      nVTCSource = get_last(dgBTNS)  
    IF(CUSTOM.VALUE2 = 13)//right display
      nTV2Source = get_last(dgBTNS)
    IF(CUSTOM.VALUE2 = 14)//send to all
    {
      nTV1Source = get_last(dgBTNS)
      nVTCSource = get_last(dgBTNS)
      nTV2Source = get_last(dgBTNS)
    }  
    send_string 0,"'nDragAddress = ',ITOA(get_last(dgBTNS))"
    send_string 0,"'nTV1Source = ',ITOA(nTV1Source)"
    send_string 0,"'nVTCSource = ',ITOA(nVTCSource)"
    send_string 0,"'nTV2Source = ',ITOA(nTV2Source)"
    
    SWITCH (get_last(dgBTNS))
    {
      CASE 1://BLURAY
      {
        SEND_COMMAND dvTP,"'^PPN-[src]DVD1'"	
	SEND_COMMAND dvTP,"'^BMP-',ITOA(get_last(dgTARGETS)+30),',0,SZ9_icon-bluraySM.png'"	
      }
      CASE 2://COMPUTER
      {
        SEND_COMMAND dvTP,"'^PPN-[src]PC1'"
	IF(get_last(dgTARGETS) < 4)//not send to all
	    SEND_COMMAND dvTP,"'^BMP-',ITOA(get_last(dgTARGETS)+30),',0,SZ9_icon-pcSM.png'"
	ELSE    
	    SEND_COMMAND dvTP,"'^BMP-31.33,0,SZ9_icon-pcSM.png'"
      }
      CASE 3://ENZO
      {
        SEND_COMMAND dvTP,"'^PPN-[src]ENZO1'"
	IF(get_last(dgTARGETS) < 4)//not send to all
	    SEND_COMMAND dvTP,"'^BMP-',ITOA(get_last(dgTARGETS)+30),',0,SZ9_icon-enzoSM.png'"
	ELSE    
	    SEND_COMMAND dvTP,"'^BMP-31.33,0,SZ9_icon-enzoSM.png'"
      }
      CASE 4://LAPTOP
      {
        SEND_COMMAND dvTP,"'^PPN-[src]Laptop1'"
	SEND_COMMAND dvTP,"'^ANI-99,1,36,30'"
	IF(get_last(dgTARGETS) < 4)//not send to all
	    SEND_COMMAND dvTP,"'^BMP-',ITOA(get_last(dgTARGETS)+30),',0,SZ9_icon-laptopSM.png'"
	ELSE    
	    SEND_COMMAND dvTP,"'^BMP-31.33,0,SZ9_icon-laptopSM.png'"
      }
      CASE 5://VTC
      {
        SEND_COMMAND dvTP,"'^PPN-[src]VTC1'"	
	SEND_COMMAND dvTP,"'^BMP-',ITOA(get_last(dgTARGETS)+30),',0,SZ9_icon-video-confSM.png'"	
      }
    }
  }  
}
//Custom event for CANCEL [5]
//A CANCEL event occurs when a draggable has been released over anything that
//is not a VALID dropTarget.
CUSTOM_EVENT[dvTP,dgBTNS,5]
{
    SEND_STRING 0,"'cancel = ', ITOA(CUSTOM.VALUE1)"
}
// Pressing logo button clears selected sources
BUTTON_EVENT[dvTP,6]
{
    PUSH:
    {
        OFF[dvTP,dgBTNS]
	SEND_COMMAND dvTP,"'^TXT-31.33,0, '"
	SEND_COMMAND dvTP,"'^BMP-31.33,0,blank.png'"
	nTV1Source = 0
        nVTCSource = 0
        nTV2Source = 0 
    }
}
// pressing output device buttons will page flip to currently connected source device page
BUTTON_EVENT[dvTP,11]//left display
{
    PUSH:
    {
      SWITCH (nTV1Source)
      {    
        CASE 1://BLURAY
        {
          SEND_COMMAND dvTP,"'^PPN-[src]DVD1'"
        }
        CASE 2://COMPUTER
        {
          SEND_COMMAND dvTP,"'^PPN-[src]PC1'"
        }
        CASE 3://ENZO
        {
          SEND_COMMAND dvTP,"'^PPN-[src]ENZO1'"
        }
        CASE 4://LAPTOP
        {
          SEND_COMMAND dvTP,"'^PPN-[src]Laptop1'"
	  SEND_COMMAND dvTP,"'^ANI-99,1,36,30'"
        }
        CASE 5://VTC
        {
          SEND_COMMAND dvTP,"'^PPN-[src]VTC1'"
        }
      } 
    }
}
BUTTON_EVENT[dvTP,12]//video conference
{
    PUSH:
    {
      SWITCH (nVTCSource)
      {    
        CASE 2://COMPUTER
        {
          SEND_COMMAND dvTP,"'^PPN-[src]PC1'"
        }
        CASE 3://ENZO
        {
          SEND_COMMAND dvTP,"'^PPN-[src]ENZO1'"
        }
        CASE 4://LAPTOP
        {
          SEND_COMMAND dvTP,"'^PPN-[src]Laptop1'"
	  SEND_COMMAND dvTP,"'^ANI-99,1,36,30'"
        }
      } 
    }
}
BUTTON_EVENT[dvTP,13]//right display
{
    PUSH:
    {
      SWITCH (nTV2Source)
      {    
        CASE 1://BLURAY
        {
          SEND_COMMAND dvTP,"'^PPN-[src]DVD1'"
        }
        CASE 2://COMPUTER
        {
          SEND_COMMAND dvTP,"'^PPN-[src]PC1'"
        }
        CASE 3://ENZO
        {
          SEND_COMMAND dvTP,"'^PPN-[src]ENZO1'"
        }
        CASE 4://LAPTOP
        {
          SEND_COMMAND dvTP,"'^PPN-[src]Laptop1'"
	  SEND_COMMAND dvTP,"'^ANI-99,1,36,30'"
        }
        CASE 5://VTC
        {
          SEND_COMMAND dvTP,"'^PPN-[src]VTC1'"
        }
      } 
    }
}
